.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1000000	; 1000000 would be a typical value

.data
hexstring	db "12345678", 0

.code
start:
	push 1
	call ShowCpu						; print brand string and SSE level

	push offset hexstring
	call atodL
	.if eax!=12345678
		print str$(eax), 9, "ERROR atodL", 13, 10
	.endif

	push offset hexstring
	call atodJJ
	.if eax!=12345678
		print str$(eax), 9, "ERROR atodJJ", 13, 10
	.endif

	REPEAT 2

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push offset hexstring
			call atodL
		counter_end
		print str$(eax), 9, "cycles for atodL: Lingo's replacement", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push offset hexstring
			call atou
		counter_end
		print str$(eax), 9, "cycles for atou: improved by hutch", 13, 10, 10

	ENDM
	print "Code size:", 13, 10
	mov eax, atodL_endp
	sub eax, atodL_s
	print str$(eax), 9, "atodL Lingo", 13, 10
	mov eax, atou_o
	sub eax, atou_i
	print str$(eax), 9, "atou Hutch", 13, 10


	inkey chr$(13, 10, "--- ok ---", 13)
	exit

align 16
atodL_s:
atodL proc ; String:DWORD
    mov    edx, [esp+1*4]
    movzx  eax, byte ptr [edx]
    add    edx, 1
    test   eax, eax
    jz    quit
    movzx  ecx, byte ptr [edx]
    sub    eax, 30h
    test   ecx, ecx
    jz    quit
@@:
    inc    edx
    lea    eax, [eax+eax*4]
    cmp    byte ptr [edx], 0
    lea    eax, [ecx+eax*2-30h]
    movzx  ecx, byte ptr [edx]
    jnz    @b
  quit:
    pop ecx
    pop edx
    jmp ecx
atodL   endp
atodL_endp:

align 16
atodJJ_s:
atodJJ proc ; String:DWORD
	mov edx, [esp+4]
	xor eax, eax

@@:	movzx ecx, byte ptr [edx]
	inc edx
	lea eax, [eax+eax*4]
	cmp byte ptr [edx], ch
	lea eax, [ecx+eax*2-30h]
	jnz @b
	ret 4
;	pop ecx
;	pop edx
;	jmp ecx
atodJJ   endp
atodJJ_endp:

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

atou_i:     ; in label

atou proc String:DWORD

  ; ------------------------------------------------
  ; Convert decimal string into UNSIGNED DWORD value
  ; ------------------------------------------------

    mov edx, [esp+4]
    xor ecx, ecx
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jz quit

  lpst:
    add edx, 1
    lea ecx, [ecx+ecx*4]            ; mul ecx * 5
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jz quit

    add edx, 1
    lea ecx, [ecx+ecx*4]            ; mul ecx * 5
    lea ecx, [eax+ecx*2-48]
    movzx eax, BYTE PTR [edx]
    test eax, eax
    jnz lpst

  quit:
    lea eax, [ecx]

    ret 4

atou endp

atou_o:     ; out label

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

ShowCpu proc
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]